Bug 36138 - UI EDITING: UNDO button inactive also in DRAW
Summary: UI EDITING: UNDO button inactive also in DRAW
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Impress (show other bugs)
Version:
(earliest affected)
3.3.2 release
Hardware: All All
: high normal
Assignee: Thorsten Behrens (CIB)
URL:
Whiteboard: VOTE target:3.7.0 target:3.6.1 target...
Keywords:
Depends on:
Blocks:
 
Reported: 2011-04-11 13:07 UTC by gleppert
Modified: 2013-02-14 14:32 UTC (History)
6 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description gleppert 2011-04-11 13:07:07 UTC
I think that missing "undo"/"redo" in Impress is a very critical problem which not only deters new users coming to LibreOffice Impress. I assume that this issue/enhancement-request must already be known by the developers. However, I could not find an existing bug entry. Here it is:

How to reproduce:
- Open an empty presentation
- Enter some text into the content frame of the slide. While typing, the buttons "undo" and "redo" are greyed out. These buttons are simply not working.
- If you click with the mouse somewhere outside the main content frame, then the "undo"/"redo" buttons resume to work again. If you once click on "undo", EVERYTHING having edited last time within the content frame is being undone.

In other words: Since a user who creates a presentation is almost always working in the content part of the slide, this issue is a terrible drawback of Impress. It makes Impress almost unusable.

This issue made every single colleague of mine swearing badly when they had to use Impress. Although they really like using Writer, they kindly asked me to send them Powerpoint files instead of Impress files. The only reason is this issue.
Comment 1 gleppert 2011-05-14 03:56:46 UTC
Please have a look at this. It might be a bug and not an enhancement. In LibreOffice 3.4b5 I made an interesting discovery concerning this issue:

For the main content frame, it is never possible to have the UNDO functionality while typing. UNDO is only possible for everything edited after actually editing.

However, if you add an additional text frame to the slide, LO's behaviour is inconsistent.

* Sometimes, there is no UNDO-functionality available, exactly like in the main content frame.
* Sometimes, however, the UNDO-functionality works like it should be: The UNDO-button is visible and it is possible to actually delete the last editing word by word.
* Sometimes, however, the UNDO-functionality works only partly: While editing the UNDO-button is greyed out and becomes only visible when you move the mouse over it and wait for a few seconds. Then, and only then, UNDO works like it should.

Should we consider this a BUG instead of an ENHANCEMENT?
Anyway, Impress's behaviour regarding UNDO is very annoying and time consuming.
Comment 2 gleppert 2011-05-14 04:10:01 UTC
After some more testing, I change this from enhancement to "bug major". LibreOffice simply behaves inconsistent. I consider this as "major loss of function" as typing, undo and redo are very basic and standard tasks.

* In title frame, UNDO works only sometimes (as described above)
* In main content frame, UNDO never works
* In additional text frames UNDO works only sometimes.
* If you add a standard form and type text into is, UNDO always works correctly.
Comment 3 gleppert 2011-05-14 04:27:57 UTC
Sorry for posting to this bug report a third time within an hour. 

I now had rare occasions where UNDO was even working in the main content frame of the slide. However, UNDO works correctly only very very rarely, let's say, only every 30th time clicking into the main content frame and typing something there.

Thanks.
Comment 4 gleppert 2011-05-14 14:02:11 UTC
I figured out that OOo (3.4Beta) behaves exactly the same, hence I also filed a bug report in the sister project OpenOffice: http://openoffice.org/bugzilla/show_bug.cgi?id=118024
Comment 5 gleppert 2011-06-23 12:43:57 UTC
As this is an fundamental bug that affects EVERY LibreOffice Impress user, could anyone have a look at it? Maybe there is an easy fix for this issue. Thanks!
Comment 6 Korrawit Pruegsanusak 2011-06-29 07:45:55 UTC
related to bug 34548 - EDITING: Impress undo fails -> crashes ?
Comment 7 Rainer Bielefeld Retired 2011-08-01 05:47:29 UTC
[Reproducible] with "LibreOffice 3.4.2  - WIN7  Home Premium (64bit) German UI [OOO340m1 (Build:203)]" in DRAW
I did not see it working with LibO 3.3.2 Portable
Works with OOo 3.1.1, Broken in OOo-dev3.2

For me Undo works fine from Menu, the problem only is the inactive Undo Button. Same behavior in DRAW and IMPRESS.

@Thorsten:
Please feel free to reassign if you do not want to be the assignee.
Comment 8 gleppert 2012-04-12 10:05:06 UTC
This problem is still there in 3.5.2.

Is it really complicated to fix? Quoting Rainer: "Undo works fine from Menu, the problem only is the inactive Undo Button"
Comment 9 Rainer Bielefeld Retired 2012-05-13 23:07:07 UTC
@Ivan:
Can you help here?
Comment 10 Ivan Timofeev (retired) 2012-05-14 12:26:29 UTC
Hmm, no idea...
It looks like *both* the menu item state and the tool button state are controlled by ViewShell::GetMenuState (sd/source/ui/view/viewshe3.cxx), but then why this bug appear? And why the tool button becomes normal when I simply hide and show it? Maybe some invalidation problems?...
Comment 11 gleppert 2012-06-16 11:35:12 UTC
According to related bug in Apache OpenOffice there is a patch for it: https://issues.apache.org/ooo/show_bug.cgi?id=119400

Could anybody be so kind to have a look at it? Thanks

P.S: Actually, that that patch solves the problem is actually a statement in comment 8 here: https://issues.apache.org/ooo/show_bug.cgi?id=118024
Comment 12 Ivan Timofeev (retired) 2012-06-28 03:12:31 UTC
(In reply to comment #11)
> According to related bug in Apache OpenOffice there is a patch for it:
Thanks for the notice, unfortunately it does not fix this bug.
Comment 13 Not Assigned 2012-08-03 16:48:12 UTC
Ivan Timofeev committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=c6fdd2e4e5a54b388d25ca0fc97e1f325ae7a566

fdo#36138: sd: fix undo in text objects
Comment 14 gleppert 2012-08-03 21:31:11 UTC
@Ivan: Thanks a lot! This is indeed very helpful for all Impress users.
Comment 15 Ivan Timofeev (retired) 2012-08-04 17:10:57 UTC
By the way, I see the same problem in Calc (in case you first double-click to a cell, then type a text; or in the input line). Can't find a bug report for that though.
Comment 16 Not Assigned 2012-08-08 11:53:19 UTC
Ivan Timofeev committed a patch related to this issue.
It has been pushed to "libreoffice-3-6":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=e3ba44a70abe6541a57ea55f9abdbc32182724d2&g=libreoffice-3-6

fdo#36138: sd: fix undo in text objects


It will be available in LibreOffice 3.6.1.
Comment 17 Not Assigned 2012-08-08 11:59:40 UTC
Ivan Timofeev committed a patch related to this issue.
It has been pushed to "libreoffice-3-5":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a5eba4ac49a6ee31ef5db31c72b7b91007c037ef&g=libreoffice-3-5

fdo#36138: sd: fix undo in text objects


It will be available in LibreOffice 3.5.7.